# GPT-Academic Report
# Title:



Dynamical evolution of discrete epidemic models

# Abstract:



The dynamical evolution of a deterministic epidemic model is studied. We model the system by taking into account an intermediate class of population, say infected, which after a latency period enter into the infectious class. A mortality rate induced by the disease is also considered. The system evolves towards a ÿnal state which may develop a catastrophic epidemic if small outbreaks of the disease emerge. The ÿnal size, the threshold and the severity of the epidemic are also analyzed and calculated for this model.

# Meta Translation

<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
好，我现在需要处理用户的请求。他给了我一篇学术论文的基本信息，包括标题、作者和摘要，希望我把这些翻译成中文。首先，我要确认用户的具体需求。他特别指出要翻译标题和摘要，所以我要分别处理这两部分。

接下来，看看标题部分：“Dynamical evolution of discrete epidemic models”。这是一个学术性的标题，我需要准确传达“动态演化”和“离散流行病模型”的概念。翻译时要注意术语的准确性，比如“dynamical evolution”译为“动力学演化”比较合适，而“discrete epidemic models”则是“离散流行病模型”。

然后是摘要部分。摘要中的信息较多，包括研究内容、模型设定、分析结果等。首先，我要理解每个句子的意思，确保翻译后的中文摘要逻辑清晰，信息完整。例如，“We model the system by taking into account an intermediate class of population”可以翻译成“我们通过考虑一个中间的人口类别来对系统进行建模”。

此外，我要确保专业术语的一致性，比如“latency period”是“潜伏期”，“mortality rate”是“病亡率”。同时，句子的结构要符合中文的表达习惯，避免直译造成的生硬感。

考虑到用户可能是一位研究人员或学生，他们需要准确的翻译来理解论文内容，所以翻译质量非常重要。我还需要注意摘要中的关键点，如系统演化的终点、可能的灾难性疫情、最终规模、阈值和严重性等，这些都需要准确无误地传达。

最后，检查整个翻译，确保没有语法错误，逻辑通顺，专业术语使用正确。完成后，与用户确认是否需要进一步调整或补充信息，以满足他们的具体需求。
</think>

标题：离散流行病模型的动力学演化  

摘要：研究了一个确定性流行病模型的动力学演化。我们通过考虑一个中间的人口类别来对系统进行建模，该类别在经过潜伏期后进入具有传染性的类别。模型还考虑了由疾病引起的病亡率。系统演化会趋向一个最终状态，如果疾病的小规模爆发出现，该状态可能会发展成一场灾难性的流行病。模型还对流行病的最终规模、阈值和严重性进行了分析和计算。

# Introduction
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
嗯，用户之前让我帮忙翻译学术论文的Abstract部分，现在又需要处理Introduction章节。好的，首先我需要仔细阅读用户给的英文段落，确保理解每个句子的意思。

用户是学术翻译，所以翻译要准确，同时保持学术风格。不能漏掉任何一个句子，还要注意术语的正确性。比如，“Mathematical epidemic models”应该翻译成“数学流行病模型”，而“dynamical evolution”则是“动力学演化”。

接下来，用户提到论文模型与Kermack-McKendrik模型类似，但引入了离散方程，并增加了受感染人群作为第四类。这里需要准确翻译这些专业术语，确保模型描述清晰。

还有，用户强调他们不考虑扩散效应，所以无法计算传播速度，这一点要准确表达出来。此外，关于潜伏期对传播速度的影响，用户提到了其他领域的例子，比如森林火灾和人类迁移，这部分也需要准确翻译，可能需要调整句子结构以符合中文表达习惯。

最后，用户的目标是分析潜伏期对阈值和最终规模的影响，以及研究首次演化过程中流行病的行为。这部分翻译时要确保逻辑连贯，术语准确，不会让读者产生误解。

总的来说，翻译时需要既忠实原文，又适应中文的表达习惯，确保专业性和可读性。遇到复杂句子时，可能需要拆分或调整结构，使译文更流畅自然。同时，要检查是否有任何遗漏或误译，确保每一个细节都准确传达。
</think>

### 引言

数学流行病模型已被广泛用于计算和描述流行病的动力学演化及其最终规模、阈值以及严重性[1][2][3]，其中最古老的模型归功于伯努利[4]。一个广为使用的是Kermack-McKendrick模型[5]，该模型研究了一个包含三类人群的系统：易感者、传染者和移除者。我们的模型与该模型类似，但引入了离散方程，这是一种在种群动力学中广为人知的方法[6]。此外，我们引入了第四类人群，即感染人群，这类人群由一个与疾病潜伏期相关的参数所描述。我们的模型无法计算流行病的传播速度，因为扩散效应未被考虑在内（传播速度已在其他研究中得到分析[7]）。潜伏期或潜伏期对应于一个延迟时间，最近的研究表明，潜伏期对于流行病传播速度[7]、森林火灾[8]和人类迁移[9]都具有重要意义。因此，分析潜伏期对疾病阈值和最终规模的影响具有重要意义，这是本文的核心目标。我们还分析了流行病首次演化过程中的稳定性条件，即在疾病发生小规模爆发并对种群产生灾难性影响时，研究流行病在最终状态附近的行为。

# The discrete model
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
今天，我遇到了一个翻译任务，需要将一篇关于离散时间流行病模型的论文章节翻译成中文。对于我这样一个刚开始学习翻译的人来说，这个任务既充满挑战，又让我感到兴奋。

首先，我通读了一遍整个章节，试图理解其核心内容和主要目的。我发现，作者介绍了一个包含四个群体（易感者、受感染者、传染者和移除者）的离散时间流行病模型，并研究了该模型的动力学演化。这个模型考虑了潜伏期和疾病引起的死亡率，这对于准确模拟流行病的传播非常重要。

接下来，我决定逐句翻译，确保每个术语和概念都能准确地表达出来。翻译过程中，我遇到了一些专业术语，比如“latency period”（潜伏期）、“mortality rate”（死亡率）、“effective transmission”（有效传播）等。我查阅了一些参考资料，确保我使用的中文术语既符合学术规范，又能让读者理解。

数学表达式部分给了我更大的挑战。在英文中，变量和方程的表示虽然清晰，但在翻译成中文时，需要确保符号和表达式的一致性，避免混淆。比如，方程中的符号“x_n”需要保持不变，而方程本身的解释需要准确无误。我决定保留变量符号，同时在周围添加适当的中文解释，以帮助读者理解。

在翻译“dynamical evolution”（动力学演化）这个术语时，我思考了一下，是否需要使用更符合中文表达习惯的词汇。经过查阅，我发现“动力学演化”已经是一个常见的翻译，因此决定沿用这个术语。

有时候，一段话中的逻辑关系比较复杂，我需要多次阅读，理解作者的推理过程，才能准确地翻译出来。例如，在解释方程（2.1）时，作者提到，“q_n = (1 -p)^{z_n}”是易感者在采样期间不被传染的概率。我需要准确翻译“avoid becoming infected”，并确保表达出指数部分的含义。

在翻译关于模型参数的部分，如“b being the proportion of infectious individuals which remain infectious at the end of each sampling interval”，我需要明确“b”代表的含义，并确保在中文中表达清楚。我查阅了相关文献，发现“b”常被翻译为“保持率”或“残留率”，最终决定使用“保留率”来更准确地表达其含义。

在整体结构上，我注意到原文使用了多个数学方程和定义，这在翻译时需要特别注意格式和标点符号的使用。我决定将方程部分保持与原文一致，同时在周围添加适量的解释和连接词，使内容更加流畅。

另外，我在处理句子的语气和语态时也需要小心。原文中多使用被动语态，这在学术写作中很常见。但在翻译成中文时，有时候主动语态可能会更自然和易读。因此，我需要根据具体情况，适当调整语态，以确保译文既忠实于原文，又符合中文的表达习惯。

在翻译某些句子较长的段落时，我感到有些吃力。为了更好地理解句子的结构和意图，我决定先理解每句话的主要信息，再逐步将其翻译成中文。这样可以避免遗漏重要细节或误解作者的意思。

在翻译过程中，我反复核对了自己完成的部分，确保术语的一致性和表达的准确性。对于不太确定的翻译，我尝试寻找相关的参考资料或例句，帮助自己做出正确的选择。

最后，我回顾了整个章节的译文，对整体流畅度和准确性进行了检查。我注意到一些地方可能还可以进一步优化，于是对这些部分进行了修改，以提高译文的可读性。

整个翻译过程中，我意识到耐心和细致是非常重要的。每一个术语和句子的处理都需要仔细推敲，以确保译文既忠实于原文，又符合目标语言的表达习惯。同时，这也让我更加深入地理解了离散时间流行病模型的运作机制和相关研究的方法论。

总的来说，这次翻译任务让我在学术翻译方面积累了一些宝贵的经验，也让我对相关领域的知识有了更深的认识。未来，我将继续提升自己的翻译技能，同时不断扩展自己的专业知识，以更好地完成各种翻译任务。
</think>

# 离散模型章节翻译：

我们提出了一种离散时间确定性模型，用于研究考虑到潜伏期以及疾病导致的死亡率的流行病的动力学演化。此模型涉及四个群体：易感者（xₙ）、感染者（yₙ）、传染者（zₙ）和移除者（rₙ）。所有易感者对疾病均无免疫力。感染者是从易感者中感染疾病但在潜伏期内尚未具备传染能力的个体。经过潜伏期后，感染者转变为传染者，此时他们能够传播疾病。我们假设疾病通过易感者与传染者之间的直接接触传播，如同病毒性疾病一样。现在我们来构建模型。设p为易感者与传染者在采样时间段内发生有效疾病传播的概率。因此，1-p是避免传播并保持为易感者的概率。易感者在采样时间段n中避免被所有zₙ传染者感染的概率为：
qₙ = (1 - p)^{zₙ} : (2.1)
因此，下一个采样时间段n+1的易感者数量为保持易感的易感者数量，即qₙxₙ。由此可得：
xₙ₊₁ = (1 - p)^{zₙ}xₙ ; (2.2)
我们假设离开易感者群体的个体全部进入感染者群体。此外，我们假设感染者的一定比例（与潜伏期相关）在每个采样时间段结束时仍处于感染状态。因此，
yₙ₊₁ = [1 - (1 - p)^{zₙ}]xₙ + yₙ ; (2.3)
下一个采样时间段n+1的传染者数量是bzₙ（b为每个采样时间段结束时仍保持传染能力的传染者比例）加上不再保持感染状态而转变为传染状态的感染者数量。因此，
zₙ₊₁ = (1 - λ)yₙ + bzₙ ; (2.4)
其中，b可视为传染者的预期寿命，而参数λ与潜伏期相关：当潜伏期较大时，成为传染者的感染者比例1 - λ较小，反之亦然，因此1 - λ ≈ 1/λ。最后，下一个采样时间段n+1的移除者数量为之前的移除者数量加上死亡的传染者数量，即：
rₙ₊₁ = rₙ + (1 - b)zₙ :(2.5)
研究的对象是由以下非线性离散方程组成的系统：
xₙ₊₁ = (1 - p)^{zₙ}xₙ ;
yₙ₊₁ = [1 - (1 - p)^{zₙ}]xₙ + yₙ ;
zₙ₊₁ = (1 - λ)yₙ + bzₙ ;
rₙ₊₁ = rₙ + (1 - b)zₙ ; (2.6)
可以观察到，
xₙ₊₁ + yₙ₊₁ + zₙ₊₁ + rₙ₊₁ = xₙ + yₙ + zₙ + rₙ = 1 ; (2.7)
如果我们对个体数量进行归一化处理。

# The threshold of the epidemic
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
嗯，好的，用户让我翻译“疫情阈值”这一章节。首先，我得理解这段内容讲的是什么。看起来是关于传染病传播的数学模型，讨论了疫情传播的条件和阈值。用户之前让我翻译过摘要，现在需要更详细的部分。

用户可能是研究人员或者学生，需要将英文的学术论文准确翻译成中文。他们是学术翻译，所以准确性和专业术语的使用非常重要。每句话都要翻译，不能遗漏信息。

看看用户给的具体段落，里面有不少数学公式，比如z₁ = (1 -)y₀ + b z₀，我得确保在翻译时保持这些公式的准确性，符号和变量名称要对应正确。同时，解释这些公式的含义时，要用合适的中文词汇，比如“阈值”、“潜伏期”等术语要准确。

用户提到“threshold”，在学术翻译中通常译为“阈值”，而这里的阈值涉及到了感染和易感人群的变化。所以，在翻译过程中，我需要确保上下文连接顺畅，比如“如果感染个体获得新的感染者，疫情就会传播”，这部分要准确传达逻辑关系。

另外，段落最后提到了一个应用例子，给出了具体的参数值和结果，比如x₀=0.8，y₀=0.1，等等。这部分的翻译需要小心处理数值和变量名称，确保读者能够清晰理解实验结果。

我还注意到，在翻译过程中，有些句子可能比较复杂，或者存在专业术语，这时候需要用简洁明确的中文表达。例如，“在没有易感个体的情况下，阈值不存在，疾病会传播”，这句话在翻译时要确保逻辑清晰，没有歧义。

此外，用户提到要对比经典模型，这一点需要在翻译中准确传达，比如“与经典模型不同，这里预测阈值依赖于潜伏期或潜伏期”，确保读者能理解这一研究的创新点。

最后，翻译完成后，建议用户检查确认是否有专业术语或学术用语需要调整，确保整体翻译的准确性和流畅性。总之，这次翻译需要精确处理术语，保持逻辑连贯，确保最终译文专业且易于理解。
</think>

### **疫情阈值**

疫情的传播取决于感染个体或传染病个体能否获得新的感染者。假设首先考虑传染病个体的第一步传播，有以下关系式：

\[
z_1 = (1 - \gamma)y_0 + bz_0
\]

为了保证 \( z_1 > z_0 \)，需满足以下条件：

\[
y_0 > y^*_0 \equiv \frac{(1 - b)z_0}{1 - \gamma}, \quad (2.8)
\]

其中 \( y^*_0 \) 是感染人群的阈值。当不存在任何传染病个体（即 \( z_0 = 0 \)）时，阈值不存在，疾病会传播。对于 \( z_0 = 0 \) 的情况，随着参数 \( b \) 值的增大，阈值会降低，并在 \( b \) 取最大可能值 \( b = 1 \) 时消失。这一结果是合乎直觉的，因为在传染病个体中没有移除机制的情况下，疾病必然会传播。

另一方面，较大的 \( \gamma \) 值对应较短的潜伏期，这会导致 epidemic 不会消亡的阈值 \( y^*_0 \) 增大。与经典模型 [5] 不同，本模型预测阈值会依赖于潜伏期或潜伏期。为了验证这一结论，我们取 \( x_0 = 0.8 \)，\( y_0 = 0.1 \)，\( z_0 = 0.1 \)，\( r_0 = 0 \)，\( p = 0.25 \)，\( \gamma = 0.2 \)，\( b = \frac{1}{3} \)，计算得 \( y^*_0 = 0.083 \)。图 1 展示了这一情况下 epidemic 的演化过程。由于满足阈值条件 (2.8)，感染在人群中传播，并最终移除了约 30% 的初始人群。这一结果展示了疾病对总人群的影响，为我们的模型提供了一个具体案例的支持。然而，我们显然需要以一种更一般的方式处理这一问题，这一问题将在下一节中进行讨论。

在进一步的分析中，我们考虑初始条件满足阈值条件 (2.8) 的情况。从图中可以看出，在这种情况下，感染人群和传染病人群的最终规模为 0，而易感人群和移除人群的最终规模分别为 0.7 和 0.3。

# The ÿnal size of the epidemic
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
今天早上，用户给了我一个新的翻译任务，关于“末日规模”这一章节的内容。看起来这是学术论文里的一段，涉及到流行病学模型中的参数。用户特别指出需要准确翻译，确保每一句话都不遗漏。

首先，我得仔细阅读用户提供的原文，理解每个术语和句子的含义。例如，“The final size of the epidemic”直接译为“末日规模”，但后面的内容需要更精确的术语。用户已经将“final size”翻译为“末日规模”，所以在翻译时要保持一致性。

接下来，段落中有很多数学符号和公式，比如(x ∞ ; y ∞ ; z ∞ ; r ∞ )，这些都是表示最终状态的人口参数。我需要确保这些符号在翻译后清晰易懂，同时保持数学表达的准确。比如，“y ∞ = z ∞ = 0”可以译为“y∞ = z∞ = 0”。

再来看整个段落，里面有些复杂的句子结构，比如从句和条件句。例如，最后一段讲到如果将概率p代入，结果是什么，以及这些结果如何与之前的图示一致。翻译时要确保这类逻辑关系清晰，不造成理解上的障碍。

另外，用户还提到了一些图示，如Fig. 1和Fig. 2。在翻译时，要保留这些引用，确保读者能够对照图表理解内容。用户特别指出这些结果与图1的渐近行为相符，所以在翻译时要准确传达这个信息。

最后，我需要检查整个翻译是否流畅，术语是否一致，并且没有遗漏任何章节内容。确保每一句话都被准确翻译，并且专业术语使用恰当，以符合学术论文的标准。

总的来说，这次翻译需要兼顾专业术语和句子结构的转换，确保最终的中文译文既准确又易于理解。特别是在处理数学公式和图表引用时，要特别注意，确保译文与原文完全一致，不造成误解。
</think>

### 末日规模

流行病中最重要的特征参数之一是易感人群的末日规模。设(x∞; y∞; z∞; r∞)为系统的最终状态。带下标∞的参数表示每个群体的末日规模。最终状态是系统(2.6)的临界点或固定点，并满足以下关系：

$$ x∞ + y∞ + z∞ + r∞ = 1 \quad (3.1) $$

其中，易感人群的末日规模定义为：

$$ x∞ = \lim_{n→∞} x_n $$

其他个体的末日规模定义方式与此类似。很容易证明x∞总是存在的：从方程(2.6)中可以看出，0 < x_{n+1} < x_n，因此序列{x_n}是一个从下界开始单调递减的序列。因此，极限总是存在的。

当n→∞时，x_{n+1}→x_n，并假设=0且b=0，从方程(2.6)和(3.1)中可以注意到：

$$ y∞ = z∞ = 0 \quad r∞ = 1 - x∞ \quad (3.2) $$

其中，x∞和r∞必须被确定。从系统(2.6)中，前两步可得：

$$ x_1 = x_0 (1 - p) z_0 \quad x_2 = x_0 (1 - p) z_0 + z_1 $$

然后通过归纳法可以得到：

$$ x_n = x_0 (1 - p)^{n-1} \sum_{i=0}^{n-1} z_i \quad (3.3) $$

另一方面，还得到：

$$ r_1 = r_0 + (1 - b) z_0 \quad r_2 = r_0 + (1 - b)(z_0 + z_1) $$

和

$$ r_n = r_0 + (1 - b) \sum_{i=0}^{n-1} z_i \quad (3.4) $$

将(3.3)和(3.4)结合起来，我们得到：

$$ x_n = x_0 \frac{r_n - r_0}{ - p} $$

其中，我们定义了辅助参数：

$$ ≡ (1 - p)^{1/(1 - b)} $$

并且从r∞ = 1 - x∞，我们最终得到：

$$ x∞ = ≡ x∞ \quad (3.5) $$

其中：

$$ ≡ x_0 \frac{1 - r_0}{1 - b} $$

方程(3.5)是一个超越方程，必须通过数值方法求解以确定x∞的值。与流行病相关的另一个特征参数是流行病的严重性，它可以定义为：

$$ S ≡ \frac{x_0 - x∞}{x_0} $$

因此，方程(3.5)可以写成：

$$ 1 - S = (1 - p) \frac{1 - x_0 (1 - S) - r_0}{1 - b} \quad $$

如果我们采用与图1相同的参数值，我们得到x∞=0.7，r∞=0.3，严重性为S=0.125。我们注意到这些结果与图1的渐近行为一致。我们还可以绘制x∞和严重性S作为有效传播概率p的函数。这就是图2所示的情况，其中我们观察到易感人群的末日规模随着p的增加而减少，这意味着在流行病结束时，易感人群的数量越少，有效传播概率越大。这是符合预期的，这也对应于严重性随着p增加而增加的事实。有趣的是，参数对流行病的末日规模没有影响(见方程(3.5))。因此，我们得出结论：尽管在模型中引入潜伏期对流行病传播的感染人口阈值y*0具有非常重要的影响(见方程(2.8))，但流行病的严重性不受的值的影响。

# Stability analysis of the ÿnal size
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
今天，我收到了一个请求，需要将一篇学术论文的章节“Stability analysis of the final size”准确地翻译成中文。这个章节具体探讨了在确定性流行病模型中，流行病最终规模的稳定性分析。作为学术翻译，首先我需要通读整段内容，确保自己完全理解每一个术语和概念，然后再逐句翻译，确保原文的意思被精准传达。

首先，我注意到整段文本涉及到大量的数学符号和术语，比如“Jacobian矩阵”、“特征值稳定性”等。这些术语在翻译时需要特别小心，因为不准确可能会导致读者理解上的偏差。因此，我必须保证这些术语的中文对应是标准且常用的。

接下来，我仔细阅读了原始英文段落，发现作者讨论了在流行病结束时，通过对初期规模和最终规模差异的计算，来评估流行病的影响。此外，作者还提到了流行病最终状态对于疾病小规模爆发的敏感性，并通过线性和非线性分析来研究系统的稳定性。这些分析对于公共卫生政策的制定非常重要，因此在翻译时，我需要确保这些关键点都被清晰地表达出来。

在翻译过程中，我遇到了几个挑战。例如，有些数学表达式的结构在英文和中文中略有不同，需要仔细调整语序，以确保表达的流畅性。此外，一些复合术语，比如“nonlinear part of the equations”，在中文中并没有直接对应的表达，需要根据上下文来选择合适的翻译方式，如“非线性方程部分”。

我还在翻译过程中发现了一些可能的歧义点。例如，“The system evolves towards a final state which may develop a catastrophic epidemic if small outbreaks of the disease emerge.” 这句话中的“evolve towards”和“develop”在中文中有不同的表达方式，需要根据上下文选择最合适的词汇，以确保句子的意思被准确传达。

此外，原文中引用的数学公式和方程在翻译时也需要特别注意格式的统一性和正确性。这些公式涉及到矩阵、特征值和特征向量等内容，如果在排版上稍有不慎，可能会导致读者在理解上出现困难。因此，我在翻译过程中仔细对比原文中的公式和符号，确保它们在中文文本中同样清晰易懂。

通过以上的思考和分析，我逐步完成了整个章节的翻译工作。在整个过程中，我始终保持着对原文内容的深入理解，并且注重翻译的准确性和流畅性。我意识到，作为学术翻译，不仅要能够准确翻译术语和句子，还要具备一定的专业知识，这样才能在翻译过程中准确把握原文的含义，避免出现误解和遗漏。

在这个项目完成后，我计划再次审阅整个翻译稿，以检查是否有任何遗漏或者翻译上的失误。另外，我也考虑到与论文作者进行交流，确认某些特定术语的翻译是否符合他们的预期。这样做不仅可以提高翻译质量，还能增强读者对译文的信任感。

总结来说，这次翻译任务让我更深地理解了学术翻译的重要性。它不仅是一项语言转换工作，更是对专业知识的综合应用和理解。通过不断的实践和学习，我相信自己可以逐渐提升翻译水平，为更多的学术交流提供高质量的翻译服务。
</think>

#  最终规模的稳定性分析

在流行病结束时，可以通过比较初期规模和最终规模的差异来评估其影响。然而，实验观察表明，最终状态可能对疾病的小规模爆发非常敏感[10]。从这个意义上讲，研究在小偏差下最终规模的演变过程是相当有趣的。这也是本节的目标。为了分析固定点（x∞；0；0；r∞）的稳定性条件，我们必须将系统（2.6）在该固定点附近进行线性化。如果我们定义系统（2.6）固定点附近的线性化矩阵为L，并且定义

L = max{|λ₁|；|λ₂|；|λ₃|；|λ₄|},

其中λᵢ，i=1；2；3；4是L的特征值，固定点在且仅在L < 1时是稳定的，而当L > 1时是不稳定的。经过一些代数运算，我们得到雅可比矩阵如下：

L = ⎛ ⎜ ⎜ ⎜ ⎜ ⎜ ⎝  
1 0 x∞ ln(1 - p) 0  
0 -x∞ ln(1 - p) 0 0  
0 0 1 - b 0  
0 0 0 1 - b  
⎞ ⎟ ⎟ ⎟ ⎟ ⎟ ⎠ : (4.1)

计算L的特征值后，我们发现若x∞ > x*∞ ≡ 1 - b ln(1/(1 - p)),则固定点是不稳定的，且疾病的小规模爆发会引发新的流行病。否则，我们无法预测流行病的演变。结合方程（3.5），并在假设r₀=0后进行一些代数运算，得到：

x∞ e^{-1 + (1/x∞)} - x₀；

但这一不等式无法满足。因此，线性稳定性分析不适用于该系统，我们必须检查固定点对于系统x_{n+2}=F(x_n)或x_{n+3}=F(x_n)等的稳定性，但在这些情况下，我们的系统表现出相同的行为，并且我们无法从中提取稳定性信息。另一种研究方法是通过引入固定点的扰动来保留系统方程的非线性部分。具体来说，

x_n = x∞ + ε_n； y_n = ε_n； z_n = ε_n； r_n = r∞ + ε_n；

其中ε_n；ε_n；ε_n；ε_n表示相对于固定点（x∞；0；0；r∞）的偏差。将其代入（2.6），我们得到其中条件（2.7）可重写为ε_{n+1} + ε_{n+1} + ε_{n+1} + ε_{n+1} = 0：我们选择与第一部分相同的情况作为应用。系统的演化始于固定点（0.7,0,0,0.3）附近，并根据系统（4.2）演变。我们已经验证，对于不同的初始扰动ε₀；ε₀；ε₀；ε₀，系统演化使得易感、感染和具有传染性的人口趋于零，但被移除的人口因不同的初始扰动而趋近于不同的值。这意味着，从某种意义上说，易感个体和被移除者在疾病的小规模爆发下是不稳定的，而感染和有传染性的人口是稳定的。从实用的角度来看，这种情况描述了一种流行病的演化，它达到一个最终状态，但疾病的小规模爆发对该群体产生了一种灾难性行为。这种行为在图3中可以观察到，我们在其中展示了从小初始扰动开始接近最终状态的人口演化过程。

ε_{n+1} = (1 - p) ε_n (x∞ + ε_n) - x∞；

ε_{n+1} = [1 - (1 - p) ε_n] (x∞ + ε_n) + ε_n；

# Conclusions
<div class="reasoning_process" ><p style="margin: 1.25em 0;"></p></div>

<think>
好吧，用户是个学术翻译，负责把学术论文准确翻译成中文。注意每一句话都要翻译。之前他让我翻译了标题和摘要，现在轮到结论部分了。我得确保专业术语准确，语气学术。先通读一下原文，理解每个句子的意思。然后逐句翻译，注意保持逻辑连贯。比如，“take into account”翻译成“考虑”，“analyzed”译为“分析”，“conducted”译为“进行了”。注意术语的一致性，比如“final size”一直译成“最终规模”。还要注意句子的结构，避免直译导致的生硬，确保读起来流畅。完成后，再检查一遍，确保没有遗漏，术语正确，整体表达准确。
</think>

我们研究了一种离散确定性流行病模型，该模型考虑了潜伏期（通过引入中间类—感染个体）和疾病引起的死亡率。我们分析了流行病的特征参数，例如阈值、最终规模和疾病的严重性，并注意到潜伏期并不影响后两个参数。我们证明了易感人群的最终规模是非递增的有效传播概率 \( p \) 的函数，而疾病的严重性是 \( p \) 的递增函数。我们还对最终状态的稳定性进行了分析，并展示了在流行病的首次演变后，即使是小规模的疾病爆发也可能对种群造成灾难性影响。

