import subprocess
import time
import os

wait_seconds = 3

def ollama_guide():

    print('# 第1步下载 Ollama, 这一步为手动，请前往 https://ollama.com/ 下载安装，回车继续')
    input()

    print('# 第2步你有什么倾向的模型吗 ? ( 请前往 https://ollama.com/library/qwen2.5:1.5b 参考模型列表，请注意大模型需要大显卡！ )')
    model = input("输入模型，默认为 “qwen2.5:0.5b”，但这种微缩模型能力十分有限:").strip()
    if not model:
        model = "qwen2.5:0.5b"
        print("模型不合法，自动设置为 qwen2.5:0.5b")

    print('# 第3步运行 Ollama, 敲回车继续（看到 Send a message 界面即成功）')
    for i in range(wait_seconds): print(wait_seconds-i); time.sleep(1)
    command = f"ollama run {model}"
    subprocess.run(f'start cmd /k {command}', shell=True)

    print('# 第4步安装 学术GPT, 敲回车继续')
    input()
    for i in range(wait_seconds): print(wait_seconds-i); time.sleep(1)
    def write_config_private():
        # 定义文件路径和内容
        folder_path = "gpt_academic"
        print(os.getcwd())
        if os.getcwd().endswith('gpt_academic'):
            file_path = "config_private.py"
        else:
            file_path = os.path.join(folder_path, "config_private.py")
        content = f'\n\nLLM_MODEL = "ollama-{model}"\n'
        # 确保文件夹存在
        if not os.path.exists(folder_path):
            os.makedirs(folder_path)
        # 确保文件存在并追加写入内容
        if not os.path.exists(file_path):
            with open(file_path, "w") as file:
                file.write(content)
        else:
            with open(file_path, "a") as file:
                file.write(content)
        print(f"配置已成功写入 {os.path.abspath(file_path)}")

    from pip_setup import main
    main(config_callback=write_config_private)




if __name__ == '__main__':
    ollama_guide()